#include "EEPROM.h"
#include <NmraDcc.h>
NmraDcc  Dcc ;
DCC_MSG  Packet ;

int dt1;
int dt2;
int octet;
int octet0=10;
int posag1;
int posag10=10;
int posag2;
int posag20=10;
int IN1=3; // connecté à l'entrée IN1 du module L298
int IN2=4; // connecté à l'entrée IN2 du module L298
int IN3=5; // connecté à l'entrée IN3 du module L298
int IN4=6; // connecté à l'entrée IN4 du module L298
int numag1;
int numag2;
int a;
int b;
int c=0;
long t0=millis();
long t1=millis();
long t2=millis();




// This function is called whenever a normal DCC Turnout Packet is received
void notifyDccAccState( uint16_t Addr, uint16_t BoardAddr, uint8_t OutputAddr, uint8_t State)
{
 
 
  if (Addr==numag1) {
    a=Addr-4*int((Addr-1)/4);
    b=2*(a-1);
    posag1= OutputAddr -b;
   
if (posag1  !=  posag10) {
Serial.print("numag1=");
Serial.println(numag1, DEC) ;
Serial.print("posag1=");
Serial.println(posag1, DEC) ;
posag10=posag1;  
 }

}

  if (Addr==numag2) {
    a=Addr-4*int((Addr-1)/4);
    b=2*(a-1);
    posag2= OutputAddr -b;
   
if (posag2  !=  posag20) {
Serial.print("numag2=");
Serial.println(numag2, DEC) ;
Serial.print("posag2=");
Serial.println(posag2, DEC) ;
posag20=posag2;  
 }

}

}

void    notifyCVChange( uint16_t CV, uint8_t Value)
{
  Serial.print(CV,DEC) ;
  Serial.print(',');
  Serial.println(Value,DEC) ;
  if (CV==1){ 
  numag1=Value;
  Serial.print("numag1=");
  Serial.println(numag1,DEC) ;
  EEPROM.write(2, numag1);  // enregistrement de l'adresse de l'aiguille 1 dans l'EEPROM   
  c=1;
  t0=millis();
  digitalWrite(13,HIGH);
  }
  if (CV==2){ 
  dt1=Value;
  Serial.print("dt1=");
  Serial.println(dt1,DEC) ;
  EEPROM.write(3, dt1);  // enregistrement de la vitesse du moteur de l'aiguille 1 dans l'EEPROM 
  c=1;
  t0=millis();
  digitalWrite(13,HIGH);
 }
  if (CV==3){ 
  numag2=Value;
  Serial.print("numag2=");
  Serial.println(numag2,DEC) ;
  EEPROM.write(4, numag2);   // enregistrement de l'adresse de l'aiguille 2 dans l'EEPROM    
  c=1;
  t0=millis();
  digitalWrite(13,HIGH);
  }
  if (CV==4){ 
  dt2=Value;
  Serial.print("dt2=");
  Serial.println(dt2,DEC) ;
  EEPROM.write(5, dt2);  // enregistrement de la vitesse du moteur de l'aiguille 2 dans l'EEPROM 
  c=1;
  t0=millis();
  digitalWrite(13,HIGH);
 } 
  

}


void setup() {
  // initialize the LED pin as an output:
  Serial.begin(9600);
  pinMode(IN1, OUTPUT);      
  pinMode(IN2, OUTPUT); 
  pinMode(IN3, OUTPUT); 
  pinMode(IN4, OUTPUT); 
  pinMode(13, OUTPUT); 
 
  digitalWrite(IN1, LOW);  
  digitalWrite(IN2, LOW);  
  digitalWrite(IN3, LOW);  
  digitalWrite(IN4, LOW);  
   
numag1=EEPROM.read(2); // lecture de l'adresse de l'accessoire enregistrée dans l'EEPROM
dt1=EEPROM.read(3); // lecture de l'adresse de l'accessoire enregistrée dans l'EEPROM
numag2=EEPROM.read(4); // lecture de l'adresse de l'accessoire enregistrée dans l'EEPROM
dt2=EEPROM.read(5); // lecture de l'adresse de l'accessoire enregistrée dans l'EEPROM

Serial.print("numag1=");
Serial.print(numag1,DEC) ;
Serial.print("dt1=");
Serial.println(dt1,DEC) ;
Serial.print("numag2=");
Serial.print(numag2,DEC) ;
Serial.print("dt2=");
Serial.println(dt2,DEC) ;

Serial.println("NMRA DCC Example 1");
  // Call the main DCC Init function to enable the DCC Receiver
  Dcc.init( MAN_ID_DIY, 10, FLAGS_OUTPUT_ADDRESS_MODE | FLAGS_DCC_ACCESSORY_DECODER | FLAGS_ENABLE_INT0_PULL_UP, 0 );
  Serial.println("Init Done");
}

void loop()
{
 Dcc.process();   

if (posag1==1 && millis()<t1+dt1) {
digitalWrite(IN1,HIGH);
digitalWrite(IN2,LOW);
}

if (posag1==1 && millis()>t1+dt1 && millis()<t1+20) {
digitalWrite(IN1,LOW);
digitalWrite(IN2,LOW);
}

if (millis()>t1+20) t1=millis();

if (posag1==0 && millis()<t1+dt1) {
digitalWrite(IN1,LOW);
digitalWrite(IN2,HIGH);
}

if (posag1==0 && millis()>t1+dt1 && millis()<t1+20) {
digitalWrite(IN1,LOW);
digitalWrite(IN2,LOW);
}

if (posag2==1 && millis()<t2+dt2) {
digitalWrite(IN3,HIGH);
digitalWrite(IN4,LOW);
}

if (posag2==1 && millis()>t2+dt2 && millis()<t2+20) {
digitalWrite(IN3,LOW);
digitalWrite(IN4,LOW);
}

if (millis()>t2+20) t2=millis();

if (posag2==0 && millis()<t2+dt2) {
digitalWrite(IN3,LOW);
digitalWrite(IN4,HIGH);
}

if (posag2==0 && millis()>t2+dt2 && millis()<t2+20) {
digitalWrite(IN3,LOW);
digitalWrite(IN4,LOW);
}

if (c==1 && millis()>t0+5000) {
  c=0;
  digitalWrite(13,LOW);
}
  
}


